**Back to:** [README](../../README.md) > [developers guide](../developers_guide.md) >

Git guidelines
==============

<p>
Here you will have some common GIT actions you want to execute while working with Nanos++.
</p>


<table class="wiki">
<tr><td> <br /><strong>GIT Patch Developers</strong> <br /><br /> </td><td> <br /><strong>GIT PM-Staff Developers</strong> <br /><br /> </td><td> <br /><strong>GIT Workflow Commands</strong> <br /><br /> </td><td> <br /><strong>GIT Workflow Commands</strong> <br /><br /> 
</td></tr><tr><td>  <br /> <strong>0) Identifying yourself in GIT (only once)</strong> <br /><br /> $ git config --global user.name "John Smith" <br /> $ git config --global user.email john.smith@university.edu <br /><br /> <strong>1) Getting the (public) repository</strong> <br /><br /> $ git clone <a class="ext-link" href="http://pm.bsc.es/git/nanox.git"><span class="icon">â€‹</span>http://pm.bsc.es/git/nanox.git</a> <br /><br /> <strong>2) Work on your master local branch</strong> <br /><br /> <em>2.1) Update files 1</em> <br /><br /> $ git commit -a -m "Fix-message-1" <br /><br /> <em>2.2) Update files 2</em> <br /><br /> $ git commit -a -m "Fix-message-2" <br /> Â· <br />   Â· <br /> Â· <br /> <em>2.n) Update files n</em> <br /><br /> $ git commit -a -m "Fix-message-n" <br /><br /> <strong>3) Update your local copy</strong> <br /><br /> $ git pull <br /><br /> <em>Resolve conflicts, if any (and then commit):</em> <br /><br /> $ git commit -a -m "Conflict Resolution" <br /><br /> <strong>4) Create patches ( and send by mail)</strong> <br /><br /> $ git format-patch origin <br /><br /> <em>It will create a list of patches:</em> <br /><br /> 0001-Fix-message-1 <br /> 0002-Fix-message-2 <br /> nnnn-Fix-message-N <br /><br /> </td><td> <br /> <strong>Identifying yourself in GIT (only once)</strong> <br /><br /> $ git config --global user.name "Juan Nadie" <br /> $ git config --global user.email juan.nadie@bsc.es <br /><br /> <strong>Checking your settings</strong> <br /><br />$ git config --list <br /><br /> <strong>Getting the (private) repository</strong><br /><br />$ git clone <a class="ext-link" href="https://pm.bsc.es/git-dev/nanox.git"><span class="icon">â€‹</span>https://pm.bsc.es/git-dev/nanox.git</a> <br /><br /> <strong>Checking current branch's status</strong> <br /><br /> $ git status <br /><br /> <strong>Checking current branch's log</strong> <br /><br /> $ git log<br /><br /> <strong>How to commit all current changes</strong> <br /><br /> $ git commit -a -m "Commit description" <br /><br /> <strong>How to commit part of current changes</strong> <br /><br /> $ git commit <em>list-of-files</em> -m "Commit description" <br /><br /> <strong>How to get updates from origin</strong> <br /><br /> $ git pull <br /><br /> <em>This is a shorthand for:</em> <br /><br /> $ git fetch <br /> $ git merge <br /><br /> <strong>How to publish your updates</strong> <br /><br /> $ git push <br /><br /> </td><td>  <br /> <strong>List local/remote branches</strong> <br /><br /> $ git branch <br /> <em>list of local branches</em> <br /><br /> $ git branch -r <br /> <em>list of remote branches</em> <br /><br /> <strong>How to switch to a local branch</strong> <br /><br /> $ git checkout branch-1 <br /><br /> <strong>How to create a local branch</strong><br /><br />$ git checkout -b branch_name<br /><br /><em>This is a shorthand for:</em><br /><br />$ git branch branch_name<br />$ git checkout branch_name<br /><br /> <strong>How to merge a branch into current one</strong> <br /><br /> $ git merge --no-ff branch_name <br /><br /> <strong>How to create a remote branch</strong><br /><br /> <em>a) from scratch...</em><br /><br />  $ git push origin origin:refs/heads/branch_name <br /><br /> <em>b) from a local branch...</em><br /><br /> $ git push origin branch_name<br /><br /> <strong>How to get a remote branch</strong><br /><br />$ git checkout -b branch_name origin/branch_name<br /><br /> </td><td> <strong>How to delete a branch</strong><br /><br /> <em>a) which is a local branch...</em><br /><br /> $ git branch -d branch_name<br /><br /> <em>b) which is a remote branch...</em><br /><br /> $ git push origin :branch_name <br /><br /> <strong>List (no) merged branches into current</strong> <br /><br /> $ git branch {--merged | --no-merged} <br /><br /> <strong>How to see differences between branches</strong> <br /><br /> $ git merge-base branch-1 branch-2 <br /> 36c7dba2c95e6bbb78dfa822519ecfec6e1ca649 <br /><br /> $ git diff 36c7db <br /><br /> <em>-- or --</em> <br /><br /> $ git diff branch-1...branch-2 <br /><br /> 
</td></tr></table>

